
# ===================================================================
#
#	zmake.mak
#
#	CF/ZAF Makefile for the basic_2d demo programs
#
# ===================================================================


# Note: CF/ZAF users must define the INCLUDE and LIB environment
#	variables. Here is an example:
# INCLUDE=	c:\zinc\cf_zaf\include;\c:\zinc\include
# LIB=		c:\zinc\lib\borland;c:\tools\bc5\lib



# ----- General CF/ZAF definitions ----------------------------------

DEBUG=off



# ----- Usage -------------------------------------------------------

usage:
	@type <<

Usage:

zmake dos16      (16 bit DOS)
zmake dos32      (32 bit DOS)
zmake win16      (16 bit Windows)
zmake win32      (32 bit Windows)
zmake win32dll   (32 bit Windows dll)
<<



# ----- Clean -------------------------------------------------------

clean:
	del *.o16
	del *.o32
	del *.ob1
	del *.obw
	del *.exe



# ----- Target name definitions -------------------------------------

DOS16_TARGETS =	\
	area16.exe bar16.exe colm16.exe line16.exe \
	pie16.exe pnt16.exe stk16.exe
DOS32_TARGETS = \
	area32.exe bar32.exe colm32.exe line32.exe \
	pie32.exe pnt32.exe stk32.exe
WIN16_TARGETS = \
	warea16.exe wbar16.exe wcolm16.exe wline16.exe \
	wpie16.exe wpnt16.exe wstk16.exe
WIN32_TARGETS = \
	warea32.exe wbar32.exe wcolm32.exe wline32.exe \
	wpie32.exe wpnt32.exe wstk32.exe
WINDLL_TARGETS = \
	warea.exe wbar.exe wcolm.exe wline.exe \
	wpie.exe wpnt.exe wstk.exe


dos16: 		$(DOS16_TARGETS)

dos32: 		$(DOS32_TARGETS)

win16: 		$(WIN16_TARGETS)

win32: 		$(WIN32_TARGETS)

win32dll:	$(WINDLL_TARGETS)




# ----- Target descriptions -----------------------------------------

TARGET =			area16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		area_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			bar16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		bar_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			colm16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		colm_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			line16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		line_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			pie16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		pie_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			pnt16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		pnt_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			stk16.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS16
SOURCE_FILES =		stk_cht.cpp
ADD_LIBRARIES =		cfzd16
DEFINITION_FILE =	b16.def
!include <zaf.mak>


TARGET =			area32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		area_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			bar32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		bar_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			colm32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		colm_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			line32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		line_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			pie32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		pie_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			pnt32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		pnt_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			stk32.exe
TARGET_TYPE =		EXE
PLATFORM =			DOS32
SOURCE_FILES =		stk_cht.cpp
ADD_LIBRARIES =		cfzd32
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			warea16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		area_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wbar16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		bar_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wcolm16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		colm_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wline16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		line_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wpie16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		pie_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wpnt16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		pnt_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			wstk16.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN16
SOURCE_FILES =		stk_cht.cpp
ADD_LIBRARIES =		cfzw16 zafw16p
DEFINITION_FILE =	win16.def
!include <zaf.mak>


TARGET =			warea32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		area_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wbar32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		bar_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wcolm32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		colm_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wline32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		line_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wpie32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		pie_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wpnt32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		pnt_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET =			wstk32.exe
TARGET_TYPE =		EXE
PLATFORM =			WIN32
SOURCE_FILES =		stk_cht.cpp
ADD_LIBRARIES =		cfzw32 zafw32p
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				area.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		area_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				bar.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		bar_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				colm.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		colm_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				line.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		line_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				pie.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		pie_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				pnt.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		pnt_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


TARGET=				stk.exe
TARGET_TYPE =		EXEDLL
PLATFORM =			WIN32
SOURCE_FILES =		stk_cht.cpp
ADD_LIBRARIES =
DEFINITION_FILE =
!include <zaf.mak>


