//////////////////////////////////////
// START of File: CE1_CCOR.HPP
//////////////////////////////////////
                    
#ifndef CE1_CCOR_HPP            // Avoid multiple includes...
#define CE1_CCOR_HPP    TRUE    // ...holds to a terminal #endif below...

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994, 1995, 1996, 1997 by DPC Technology.
// All rights reserved. 
//
// See files "cf_copyr.txt" and "cf_licen.txt" for details of 
// copyright and license specifications, and contact information.
//
//===================================================================

//
// Master Header File Listing:
//
// #include    <api/include/ce1_ccor.hpp>
//
// "Cartesian (XYZ) Coordinate" Chart Engine object 
// (derived from base "Chart-Engine").
//

//--------------------------------------------------------------------
// Include Chart Framework class or ID defs/headers this file needs.
// Paths are relative to the IDE's (global) include path: ~/cfrz
//--------------------------------------------------------------------
class       bf_Display;
class       cf_3DPoint;
class       cf_ChartModel;
class       cf_ChartEngine;
#include    <cf_api/c1_engin.hpp>
            // which pulls in the classes above...

//
// Declare a "Cartesian (XYZ) Coord Engine" object:
//
// Class cf_eng_CartXYZ models a Cartesian (XYZ) Coordinate Chart
// which will be used to produce derived Bar, Column, Stack, Point-
// Series, Line, Area, Ribbon, Charts, etc.
//
class CF_EXPORT   cf_eng_CartXYZ : public cf_ChartEngine
{

public:

    cf_eng_CartXYZ( cf_ChartType    enumChartType,
                    cf_DispMode     enumDispMode );

    virtual         ~cf_eng_CartXYZ();

    virtual void    applyDataUpdate( cf_ChartModel *p_cf_cmodlDataSource );

    virtual void    draw2D( bf_Display *p_bf_dspFromChartView );
       
    virtual void    draw3D( bf_Display *p_bf_dspFromChartView );
       
    virtual void    measureVirtMinMax();
    virtual void    measureVirtOrigin();

protected:

    virtual void    initGridTickSeries();

private:


};  //
    // End of cf_eng_CartXYZ declaration.
    //

#endif      // Terminates include re-definition protection

//////////////////////////////////////
// END of File: CE1_CCOR.HPP
//////////////////////////////////////

            
