//////////////////////////////////////
// START of File: CE2_BAR.HPP
//////////////////////////////////////

#ifndef CE2_BAR_HPP
#define CE2_BAR_HPP

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994 through 1997 by DPC Technology Corporation.
// All rights reserved by DPC Technology Corporation. 
//
// See files "cf_copyr.txt" and "cf_licen.txt" for details of 
// copyright and license specifications, and contact information.
//
//===================================================================

// Master Header File Listing:
// Usage:   #include    <cf_api/ce2_bar.hpp>
            // Class cf_eng_Bar2D builds a "flat" 2D Bar Chart 
            // from 2D Polygons:

// Include Chart Framework class or ID defs/headers this file needs.
class       cf_ChartModel;
class       cf_ChartEngine; 
class       cf_eng_CartXYZ;
#include    <cf_api/ce1_ccor.hpp>
            // We'll be using MANY base-class methods!...

class CF_EXPORT   cf_eng_Bar2D : public cf_eng_CartXYZ
{

public:

    cf_eng_Bar2D();

    virtual         ~cf_eng_Bar2D();

protected:

    virtual void    initGridTickSeries();
                    // We'll want to over-ride the base class'es
                    // grid/tick/series setup to switch our domain
                    // axis to the Y axis, and our range axes 
                    // to the X-axis!

    virtual void    updateYValsOnNatNs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // CENTERS Bars on "Natural Number" Index 
                    // Values (e.g. 1, 2, 3, .. N).
                    
    virtual void    updateYValsAtIntIs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // STARTS Bars on "Integer Number" Index 
                    // Values (e.g. 0, 1, 2, .. I).

};  // End of cf_eng_Bar2D declaration.

#endif

//////////////////////////////////////
// END of File: CE2_BAR.HPP
//////////////////////////////////////


            
