//////////////////////////////////////
// START of File: CE2_STAC.HPP
//////////////////////////////////////

#ifndef CE2_STAC_HPP
#define CE2_STAC_HPP

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994, 1995, 1996, 1997 by DPC Technology.
// All rights reserved.
//
// See files "cf_copyr.txt" and "cf_licen.txt" for details of
// copyright and license specifications, and contact information.
//
//===================================================================

// Master Header File Listing:
// Usage:   #include    <cf_api/ce2_stac.hpp>
            // Class cf_eng_Col2D builds a "flat" 2D Stack 
            // Chart from 2D Polygons:

//--------------------------------------------------------------------
// Include Chart Framework class or ID defs/headers this file needs.
//--------------------------------------------------------------------
class       cf_ChartModel;
class       cf_ChartEngine;
class       cf_eng_CartXYZ;
#include    <cf_api/ce1_ccor.hpp>
            // We'll be using MANY base-class methods!...

class CF_EXPORT   cf_eng_Stack2D : public cf_eng_CartXYZ
{

public:

    cf_eng_Stack2D();

    virtual         ~cf_eng_Stack2D();

protected:

    virtual void    initGridTickSeries();
                    // We'll want to over-ride the base class'es
                    // grid/tick/series setup to make our range
                    // axis extend over Y-val SUMs!

    virtual void    updateYValsOnNatNs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // CENTERS Stacks on "Natural Number" Index 
                    // Values (e.g. 1, 2, 3, .. N).
                    
    virtual void    updateYValsAtIntIs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // STARTS Stacks on "Integer Number" Index 
                    // Values (e.g. 0, 1, 2, .. I).

};  // End of cf_eng_Stack2D declaration.


#endif

//////////////////////////////////////
// END of File: CE2_STAC.HPP
//////////////////////////////////////


            
