//////////////////////////////////////
// START of File: CE3_RIBN.HPP
//////////////////////////////////////

#ifndef CE3_RIBN_HPP
#define CE3_RIBN_HPP

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994, 1995, 1996, 1997 by DPC Technology.
// All rights reserved. 
//
// See files "cf_copyr.txt" and "cf_licen.txt" for details of 
// copyright and license specifications, and contact information.
//
//===================================================================

//
// Master Header File Listing:
//
// #include    <cf_api/ce3_ribn.hpp>
// Class cf_eng_Ribbon3D builds a (mainly 3D) 3D/2D Ribbon Chart 
//          -- and then displays it in 3D (depth) Mode:
// Class cf_eng_Ribbon2D builds a (mainly 3D) 3D/2D Ribbon Chart 
//          -- and then displays it in 2D (flat) Mode:
//

//--------------------------------------------------------------------
// Include Chart Framework class or ID defs/headers this file needs.
// Paths are relative to the IDE's (global) include path: ~/cfrz
//--------------------------------------------------------------------
class       cf_ChartModel;
class       cf_ChartEngine; 
class       cf_eng_CartXYZ;
#include    <cf_api/ce1_ccor.hpp>
            // We'll be using MANY base-class methods!...


class CF_EXPORT   cf_eng_Ribbon3D :
        public
        cf_eng_CartXYZ
{

public:

    cf_eng_Ribbon3D();

    virtual         ~cf_eng_Ribbon3D();
                    // Virtual d-tor is critical, since owner
                    // object uses pointers to *base* type !

protected:

    virtual void    updateYValsOnNatNs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // Adds Points on "Natural Number" Index 
                    // Values (e.g. 1, 2, 3, .. N).
                    
    virtual void    updateYValsAtIntIs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // Adds Points on "Integer Number" Index 
                    // Values (e.g. 0, 1, 2, .. I).

    virtual void    updateYValsAtUsrXs
                    ( cf_ChartModel *p_cf_cmodlDataSource );
                    // Adds Points at "User X-Val" Index Values 
                    // loaded into the USER's Current Chart Model.

};  // End of cf_eng_Ribbon3D declaration.




class   cf_eng_Ribbon2D : public cf_eng_Ribbon3D
{

public:

    cf_eng_Ribbon2D();

    virtual         ~cf_eng_Ribbon2D();
                    // Virtual d-tor is critical, since owner
                    // object uses pointers to *base* type !

};  // End of cf_eng_Ribbon2D declaration.


#endif      // Terminates include re-definition protection

//////////////////////////////////////
// END of File: CE3_RIBN.HPP
//////////////////////////////////////


            
