//////////////////////////////////////
// START of File: CO1_PLIN.HPP
//////////////////////////////////////

#ifndef CO1_PLIN_HPP			// Avoid multiple includes...
#define CO1_PLIN_HPP	TRUE	// ...holds to a terminal #endif below...

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994, 1995, 1996, 1997 by DPC Technology.
// All rights reserved. 
//
// See files "cf_copyr.txt" and "cf_licen.txt" for details of 
// copyright and license specifications, and contact information.
//
//===================================================================

//
// Master Header File Listing:
//
// #include    <cf_api/co1_plin.hpp>
// Chart Framework "2D/3D Poly-Line " object.
//

//--------------------------------------------------------------------
// Include Chart Framework class or ID defs/headers this file needs.
// Paths are relative to the IDE's (global) include path: ~/cfrz
//--------------------------------------------------------------------
class 		bf_Color;
class 		cf_2DPoint;	// we generate draw-time arrays of points...
class		bf_Display;
class		cf_3DPoint;
class		cf_3DPointSeries;
#include    <cf_api/co1_pser.hpp>
			// and we'll use these pulled-in classes...


//
// Declare a Chart Framework "Poly Line" zApp class.
//
// Class cf_3DPolyLine abstracts a set of graphable Chart Framework points.
//
class CF_EXPORT	cf_3DPolyLine 

		: public cf_3DPointSeries 

{

public:

	cf_3DPolyLine();	// Default c-tor w.o. DispAttribs pointer
						// uses Pen=CF_BLACK; brush=CF_WHITE;

	cf_3DPolyLine( cf_DispAttribs *p_attrToDrawWith );
						// Std c-tor lets user assign display attribs

	virtual 		~cf_3DPolyLine();

	virtual void	draw2D( bf_Display *p_bf_dspOutputDisplay );

	virtual void	draw3D( bf_Display *p_bf_dspOutputDisplay );

protected:

private:


};	//
	// End of cf_3DPolyLine declaration.
	//

#endif		// Terminates include re-definition protection

//////////////////////////////////////
// END of File: CO1_PLIN.HPP
//////////////////////////////////////

			
