
//////////////////////////////////////
// START of File: b0_fonts.cpp
//////////////////////////////////////

//===================================================================
//
// COPYRIGHT NOTICE:  This code is protected by Copyright!
//
// Copyright (c) 1994 through 1997 by DPC Technology Corporation.
// All rights reserved. 
//
// See files "cf_copyr.h" and "cf_licen.h" for details of 
// copyright and license specifications, and contact information.
//
//===================================================================

#include	<cf_api/bf_defs.h>
#include    <cf_api/b0_fonts.hpp>





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::bf_FontSpec () 
{
	name_ = "";
	size_ = 10;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::bf_FontSpec(  	const char*		name,
                    		cf_2DRect   	dimensions,
                    		int             /*Weight*/,
                    		bf_FontFamily,
                    		bf_FontPitch,
                    		int             /*StyleFlags*/ )
{
	name_ = name;
	size_ = dimensions.height ();
	zfont_ = ZAF_FNT_NULL;
	is_internal_ = TRUE;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::bf_FontSpec(  	const char *    /*a_cFontName*/,
                    		cf_2DRect      /*bf_2drWidthAndHeight*/,
                    		int             /*iWeight*/,
                    		bf_FontFamily  /*bf_ffEnumFamilyType*/,
                  		  	bf_FontPitch   /*bf_fpEnumPitchType*/,
                		    int             /*iStyleFlags*/,
                   		 	int             /*iEscapementAngle*/,
                    		int             /*iOrientationAngle*/ )
{
	zfont_ = ZAF_FNT_NULL;
	is_internal_ = TRUE;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::bf_FontSpec(	const char *    /*a_cFontName*/,
                    		bf_DispLogFontDim  /*bf_dlfdWidthAndHeight*/,
                    		int                /*iWeight*/,
                    		bf_FontFamily      /*bf_ffEnumFamilyType*/,
                    		bf_FontPitch       /*bf_fpEnumPitchType*/,
                    		int                /*iStyleFlags*/,
                    		int                /*iEscapementAngle*/,
                    		int                /*iOrientationAngle*/ )
{
	zfont_ = ZAF_FNT_NULL;
	is_internal_ = TRUE;
}
            




//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::bf_FontSpec (ZafLogicalFont zf)
{
	zfont_ = zf;
	is_internal_ = FALSE;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontSpec::~bf_FontSpec() 
{
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

cf_String  
bf_FontSpec::fsp_faceName()
{
	return (name_);
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_Font::bf_Font ()
{
	name_ = "";
	size_ = 10;
	zfont_ = ZAF_FNT_NULL;
	is_internal_ = FALSE;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_Font::bf_Font (bf_FontSpec &spec)
{
	if (spec.fsp_isInternal ())
	{
		name_ = spec.fsp_faceName ();
		size_ = spec.fsp_size ();
		zfont_ = ZAF_FNT_NULL;
		is_internal_ = TRUE;
	}
	else
	{
		zfont_ = spec.fsp_zfont ();
		is_internal_ = FALSE;
	}
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_Font::bf_Font (ZafLogicalFont zf)
{
	zfont_ = zf;
	is_internal_ = FALSE;
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_Font::~bf_Font() 
{
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontInfo::bf_FontInfo (bf_Display*)
{
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontInfo::~bf_FontInfo()
{
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

int
bf_FontInfo::fnfo_height()
{
	return (0);
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

int
bf_FontInfo::fnfo_width()
{
	return (0);
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

int
bf_FontInfo::fnfo_weight()
{
	return (0);
}
   




//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontFamily  
bf_FontInfo::fnfo_family()
{
	return (0);
}
           




//--------------------------------------------------------------
//
//--------------------------------------------------------------

bf_FontPitch   
bf_FontInfo::fnfo_pitch()
{
	return (0);
}





//--------------------------------------------------------------
//
//--------------------------------------------------------------

BOOL
bf_FontInfo::fnfo_isItalic() 
{
	return (FALSE);
}
           




//--------------------------------------------------------------
//
//--------------------------------------------------------------

BOOL
bf_FontInfo::fnfo_isUnderlined()
{
	return (FALSE);
}
           




//--------------------------------------------------------------
//
//--------------------------------------------------------------

BOOL
bf_FontInfo::fnfo_isStruckOut()
{
	return (FALSE);
}





//////////////////////////////////////
// END of File: B0_FONTS.CPP
//////////////////////////////////////




